/***************************************************************************
 ***************************************************************************
 ***************************************************************************
 *****
 *****
 ***** Welcome!
 *****
 ***** This file is part of the robot control software provided
 ***** by Real World Interface Inc.
 *****
 ***** All copyrights are by Real World Interface Inc., Carnegie
 ***** Mellon University, and the University of Bonn, Germany.
 ***** Removing the copyright information is illegal. Please read
 ***** and make sure you understand the disclaimer below.
 *****
 ***** Contact tyson@rwii.com if you have questions or would
 ***** like to obtain further information.
 *****
 ***** We hope you enjoy working with this software package.
 *****
 *****                      Tyson D. Sawyer and Sebastian Thrun
 *****
 *****
 ***************************************************************************
 ***************************************************************************
 ***************************************************************************
 ***** 
 ***** THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED
 ***** BY APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING
 ***** THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM
 ***** "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR
 ***** IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 ***** OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE
 ***** ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
 ***** IS WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME
 ***** THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
 ***** 
 ***** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
 ***** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY
 ***** MODIFY AND/OR REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE
 ***** LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL,
 ***** INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR
 ***** INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO
 ***** LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES
 ***** SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM
 ***** TO OPERATE WITH ANY OTHER PROGRAMS OR FAILURE TO CONTROL A
 ***** PHYSICAL DEVICE OF ANY TYPE), EVEN IF SUCH HOLDER OR OTHER
 ***** PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 *****
 ***************************************************************************
 ***************************************************************************
 ***************************************************************************
 *****
 ***** Source file:     $Source: /home/uni/rhino/CVS/bee/src/tcx/ws_gethostname.c,v $
 *****
 ***** Created by:      $Author: ws $
 *****
 ***** Revision #:      $Revision: 1.3 $
 *****
 ***** Date of revision $Date: 1996/12/12 09:20:37 $
 *****
 ***************************************************************************
 ***************************************************************************
 ***************************************************************************
 *
 *                  ----- REVISION HISTORY -----
 *
 * $Log: ws_gethostname.c,v $
 * Revision 1.3  1996/12/12 09:20:37  ws
 * removed unnecessary strcat(...,.informatik.uni-bonn.de)
 * - caused unintelligent guessing on missconfigured systems
 *
 * Revision 1.2  1996/11/14 12:59:24  ws
 * ridiculous 32 byte limitation for length of hostname replaced by 256 bytes
 *
 * Revision 1.1  1996/11/04 11:53:15  ws
 * Now TCX clients and server can connect even when located in different
 * internet domains.
 *
 * Revision 1.1.1.1  1996/10/28 16:46:00  ws
 * get the fully qualified domain name of current host
 * gethostname(3) returns the hostname as set by sethostname (w/o domain)
 *
 *
 ***************************************************************************
 ***************************************************************************
 ***************************************************************************/

#include <netdb.h>
#if defined(sun) && defined(__svr4__)
#include <sys/systeminfo.h>
#endif
#include <stdio.h>

int
ws_gethostname(char *hostname,int len)
{
 struct hostent         *hp;

#if defined(sun) && defined(__svr4__)
 if (-1 == sysinfo(SI_HOSTNAME,hostname,len-1))
     return -1;
#else
 if (-1 == gethostname(hostname,len-1))
     return -1;
#endif

 hp = gethostbyname(hostname);
 if (hp)
     (void)strncpy(hostname,hp->h_name,len-1);
 hostname[len-1] = '\0';

/* 
 if (!strchr(hostname,'.'))
    fprintf(stderr,"gethostbyname(hostname)->h_name != official hostname\n");
 */

 return 0;
}
